package net.minecraft.src;

import java.util.*;
import java.lang.reflect.*;

////////////////////////////////////////////////////////////////////////////////
// l`̒`

public class EntityDoll extends EntityLiving implements IInventory
{
    // ̏p
    public boolean field_70885_d = false;
    public float field_70886_e = 0.0F;
    public float destPos = 0.0F;
    public float field_70884_g;
    public float field_70888_h;
    public float field_70889_i = 1.0F;

    // ÕbZ[W
    private String lastMsg;

    // l`̃Cxg
    private ItemStack[] dollInventory;
    public boolean isInventoryOpened;
    private final static int dollInventorySize = 36;

    // AI
    private List registeredTasks = new ArrayList();

    // ItemID
    private int itemDollID;

    // Ti
    public float searchDev;

    // WtO
    protected static boolean gatheringCall;
    static
    {
        gatheringCall = false;
    }
    
    // 
    public EntityDoll(World worldObj)
    {
        super(worldObj);
        this.setSize(0.3F, 0.7F);
        lastMsg = "";
        dollInventory = new ItemStack[dollInventorySize];
        isInventoryOpened = false;
        searchDev = 0.0F;
    }

    // iꏊwj
    public EntityDoll(World worldObj, double x, double y, double z)
    {
        this(worldObj);
        this.setPosition(x, y + (double)this.yOffset, z);
        this.motionX = 0.0D;
        this.motionY = 0.0D;
        this.motionZ = 0.0D;
        this.prevPosX = x;
        this.prevPosY = y;
        this.prevPosZ = z;
    }

    // AIgǂ
    @Override
    public boolean isAIEnabled()
    {
        return true;
    }

    // ̗͂̐ݒ
    @Override
    public int getMaxHealth()
    {
        return 8;
    }

    // ʂ̐ݒ
    @Override
    protected float getSoundVolume()
	{
		return 0.0F;
	}

    // ChÏʒu
	@Override
	public double getYOffset()
	{
		if(ridingEntity != null)
		{
            if(ridingEntity instanceof EntityPlayer)
            {
                return (double)(yOffset - 1.1F);
            }
		}
		return super.getYOffset();
	}
    
    // ̍
	@Override
	public float getEyeHeight()
	{
        return this.height;
	}
    
    // ̏
    @Override
    protected void fall(float par1)
    {
        // _[WȂ
    }

    // fX|[邩ǂ
	@Override
	protected boolean canDespawn()
	{
		return false;
	}

    // 莝ACe擾
    @Override
    public ItemStack getHeldItem()
    {
        if(isEnable())
        {
            return super.getHeldItem();
        }
        return null;
    }

    // eNX`擾
    @Override
    public String getTexture()
    {
        ItemStack item = getCurrentItemOrArmor(0);
        if(item == null)
        {
            return "/dolls/bare.png";
        }
        else if(item.itemID == Item.swordGold.shiftedIndex)
        {
            return "/dolls/shanghai.png";
        }
        else if(item.itemID == Item.pickaxeGold.shiftedIndex)
        {
            return "/dolls/horai.png";
        }
        else if(item.itemID == Block.tnt.blockID)
        {
            return "/dolls/ooedo.png";
        }
        else if(item.itemID == Block.chest.blockID)
        {
            return "/dolls/russia.png";
        }
        else if(item.itemID == Item.axeGold.shiftedIndex)
        {
            return "/dolls/germany.png";
        }
        else if(item.itemID == Item.eyeOfEnder.shiftedIndex)
        {
            return "/dolls/london.png";
        }
        else if(item.itemID == Block.mushroomRed.blockID)
        {
            return "/dolls/mrs.png";
        }
        
        return "/dolls/bare.png";
    }

    // 1TickƂɌĂ΂
    @Override
    public void onLivingUpdate()
    {
        super.onLivingUpdate();

        // ӂӂƗ
        updateFallingState();

        if(!worldObj.isRemote)
        {
            // ChI[hEntityI[i[ł͂Ȃ
            //   =>X^oC[h
            if(isRideonMode() && (!isOwner(ridingEntity)))
            {
                setStandbyMode();
            }
            // ChI[ĥƂ͉
            if(isRideonMode())
            {
                int h = getHealth();
                if(h < getMaxHealth())
                {
                    setEntityHealth(h + 1);
                }
            }
            // ɗX^oC[h
            if(isStandbyMode() && inWater)
            {
                setPatrolMode();
            }
            // W
            if(gatheringCall)
            {
                if(isPatrolMode() || isFollowMode())
                {
                    Entity entity = getOwnerEntity();
                    if(entity != null)
                    {
                        teleportToEntity(entity, 2.0);
                        setRideonMode();
                        gatheringCall = false;
                    }
                }
            }
        }
    }

    // ENbNꂽƂɌĂ΂
    @Override
    public boolean interact(EntityPlayer entityplayer)
    {
        ItemStack currentItem = entityplayer.inventory.getCurrentItem();
        
        // vC[I[i[ł͂Ȃ
        if(!isOwner(entityplayer))
        {
            // h[RAĂ΃ANeBx[V
            if(currentItem != null && currentItem.itemID == mod_Touhou_Alice_Dolls.dollCore.shiftedIndex)
            {
                setOwnerName(entityplayer.username);
                chatMessage(getDollName() + " : Activation successful!", 2);
                setStandbyMode();
                for(int i=0; i<7; ++i)
                {
                    spawnParticle("smoke");
                }
                playSE("fire.ignite", 1.0F, rand.nextFloat() * 0.4F + 0.8F);
                return true;
            }
        }
        else // vC[I[i[
        {
            if(currentItem == null)
            {
                toggleMode();
                return true;
            }
            else if(currentItem.itemID == mod_Touhou_Alice_Dolls.dollCore.shiftedIndex)
            {
                toggleEnable();
                return true;
            }
            else if(currentItem.itemID == Item.book.shiftedIndex)
            {
                toggleChatLevel();
                return true;
            }
            else if(currentItem.itemID == Block.chest.blockID)
            {
                if (!this.worldObj.isRemote)
                {
                    entityplayer.displayGUIChest(this);
                }
                return true;
            }
            else
            {
                toggleMode();
                return true;
            }
        }
        
        return super.interact(entityplayer);
    }

    // |ꂽƂɌĂ΂
    @Override
    public void onDeath(DamageSource par1DamageSource)
    {
        Entity entity = par1DamageSource.getEntity();

        if(isOwner(entity))
        {
            setDead();
        }
        if (this.scoreValue >= 0 && entity != null)
        {
            entity.addToPlayerScore(this, this.scoreValue);
        }

        if (entity != null)
        {
            entity.onKillEntity(this);
        }

        this.dead = true;

        if (!this.worldObj.isRemote)
        {
            dropItemWithTagCompound(new ItemStack(itemDollID, 1, 0));
            
            for (int slot = 0; slot < this.getSizeInventory(); ++slot)
            {
                ItemStack itemstack = this.getStackInSlot(slot);
                dropItemWithTagCompound(itemstack);
            }
        }

        this.worldObj.setEntityState(this, (byte)3);
    }

    // ACehbv
    protected void dropItemWithTagCompound(ItemStack itemstack)
    {
        if (itemstack != null)
        {
            float var3 = this.rand.nextFloat() * 0.8F - 0.4F;
            float var4 = this.rand.nextFloat() * 0.8F + 0.1F;
            float var5 = this.rand.nextFloat() * 0.8F - 0.4F;

            while (itemstack.stackSize > 0)
            {
                int var6 = this.rand.nextInt(21) + 10;

                if (var6 > itemstack.stackSize)
                {
                    var6 = itemstack.stackSize;
                }

                itemstack.stackSize -= var6;
                EntityItem var7 = new EntityItem(this.worldObj, this.posX + (double)var3, this.posY + (double)var4, this.posZ + (double)var5, new ItemStack(itemstack.itemID, var6, itemstack.getItemDamage()));

                if (itemstack.hasTagCompound())
                {
                    var7.item.setTagCompound((NBTTagCompound)itemstack.getTagCompound().copy());
                }

                float var8 = 0.05F;
                var7.motionX = (double)((float)this.rand.nextGaussian() * var8);
                var7.motionY = (double)((float)this.rand.nextGaussian() * var8 + 0.2F);
                var7.motionZ = (double)((float)this.rand.nextGaussian() * var8);
                this.worldObj.spawnEntityInWorld(var7);
            }
        }
    }

////////////////////////////////////////////////////////////////////////////////
// f[^Ǘ
    
    @Override
    protected void entityInit()
    {
        super.entityInit();

        // 
        this.dataWatcher.addObject(16, Byte.valueOf((byte)0xa0));
        // 
        this.dataWatcher.addObject(17, "");
        // l`̎
        this.dataWatcher.addObject(18, "");
    }

    // f[^̕ۑ
    @Override
    public void writeEntityToNBT(NBTTagCompound par1NBTTagCompound)
    {
        super.writeEntityToNBT(par1NBTTagCompound);

        if (this.getOwnerName() == null)
        {
            par1NBTTagCompound.setString("Owner", "");
            //System.out.println("[Save] Owner : ");
        }
        else
        {
            par1NBTTagCompound.setString("Owner", this.getOwnerName());
            //System.out.println("[Save] Owner : "+ this.getOwnerName());
        }
        if (this.getDollName() == null)
        {
            par1NBTTagCompound.setString("Name", "Bare");
            //System.out.println("[Save] Name  : Bare");
        }
        else
        {
            par1NBTTagCompound.setString("Name", this.getDollName());
            //System.out.println("[Save] Name  : "+ this.getDollName());
        }
        par1NBTTagCompound.setByte("Mode", this.getModeFlag());
        //System.out.printf("[Save] Mode  : 0x%2x%n",this.getModeFlag());
            
        // Cxg̕ۑ
        NBTTagList taglist = new NBTTagList();
        for (int index = 0; index < this.dollInventory.length; ++index)
        {
            if (this.dollInventory[index] != null)
            {
                NBTTagCompound tagcomp = new NBTTagCompound();
                tagcomp.setByte("Slot", (byte)index);
                this.dollInventory[index].writeToNBT(tagcomp);
                taglist.appendTag(tagcomp);
            }
        }
        par1NBTTagCompound.setTag("Items", taglist);
    }

    // f[^̓ǂݏo
    @Override
    public void readEntityFromNBT(NBTTagCompound par1NBTTagCompound)
    {
        super.readEntityFromNBT(par1NBTTagCompound);
        
        String var2 = par1NBTTagCompound.getString("Owner");
        if (var2 != null && var2.length() > 0)
        {
            this.setOwnerName(var2);
            //System.out.println("[Load] Owner : "+ var2);
        }
        else
        {
            this.setOwnerName("");
            //System.out.println("[Load] Owner : ");
        }

        String var3 = par1NBTTagCompound.getString("Name");
        if (var3 != null && var3.length() > 0)
        {
            this.setDollName(var3);
            //System.out.println("[Load] Name  : "+ var3);
        }
        else
        {
            this.setDollName("Bare");
            //System.out.println("[Load] Name  : Bare");
        }
        this.setModeFlag(par1NBTTagCompound.getByte("Mode"));
        //System.out.printf("[Load] Mode  : 0x%2x%n",this.getModeFlag());
        
        // Cxg̓ǂݏo
        NBTTagList taglist = par1NBTTagCompound.getTagList("Items");
        this.dollInventory = new ItemStack[dollInventorySize];
        
        for (int index = 0; index < taglist.tagCount(); ++index)
        {
            NBTTagCompound tagcomp = (NBTTagCompound)taglist.tagAt(index);
            int var5 = tagcomp.getByte("Slot") & 255;
            
            if (var5 >= 0 && var5 < this.dollInventory.length)
            {
                this.dollInventory[var5] = ItemStack.loadItemStackFromNBT(tagcomp);
            }
        }
        
    }

    // ̖Oݒ
    public void setOwnerName(String name)
    {
        this.dataWatcher.updateObject(17, name);
    }

    // ̖O擾
    public String getOwnerName()
    {
        return this.dataWatcher.getWatchableObjectString(17);
    }

    // ̃GeBeB擾
    public EntityPlayer getOwnerEntity()
    {
        return this.worldObj.getPlayerEntityByName(this.getOwnerName());
    }

    // 傩ǂ
	public boolean isOwner(Entity entity)
	{
        if(entity == null)
        {
            return false;
        }
        if(entity instanceof EntityPlayer)
        {
            EntityPlayer entityplayer = (EntityPlayer)entity;
            return entityplayer.username.equalsIgnoreCase(getOwnerName());
        }
        return false;
	}

    // l`̖Oݒ
    public void setDollName(String name)
    {
        this.dataWatcher.updateObject(18, name);
        initializeDoll(name);
    }

    // l`̖O擾
    public String getDollName()
    {
        return this.dataWatcher.getWatchableObjectString(18);
    }

    // [h̎擾
    public byte getModeFlag()
    {
        return this.dataWatcher.getWatchableObjectByte(16);
    }

    // [h̐ݒ
 	public void setModeFlag(Byte flag)
	{
		this.dataWatcher.updateObject(16, flag);
	}
	
    // 샂[hύX
    public void toggleMode()
    {
        if(isStandbyMode())
        {
            setPatrolMode();
        }
        else if(isPatrolMode())
        {
            setFollowMode();
        }
        else if(isFollowMode())
        {
            setRideonMode();
        }
        else if(isRideonMode())
        {
            setStandbyMode();
        }
    }

    // X^oC[hǂ
    public boolean isStandbyMode()
    {
        byte data = getModeFlag();
        return (data & 0x0f) == 0x00;
    }

    // X^oC[hɐݒ
    public void setStandbyMode()
    {
        if(worldObj.isRemote)
        {
            return;
        }
        mountEntity(null);
        byte data = getModeFlag();
        setModeFlag((byte)((data & 0xf0) | 0x00));
		
		chatMessage(getDollName()+" : Standby mode", 2);
		playSE("random.click", 0.3F, 0.6F);
    }

    // pg[[hǂ
    public boolean isPatrolMode()
    {
        byte data = getModeFlag();
        return (data & 0x0f) == 0x01;
    }

    // pg[[hɐݒ
    public void setPatrolMode()
    {
        if(worldObj.isRemote)
        {
            spawnParticle("note");
            return;
        }
        byte data = getModeFlag();
        setModeFlag((byte)((data & 0xf0) | 0x01));
        if(isOwner(ridingEntity))
        {
            mountEntity(null);
		}
		chatMessage(getDollName()+" : Patrol mode", 2);
		playSE("random.click", 0.3F, 0.6F);
        
    }

    // tH[[hǂ
    public boolean isFollowMode()
    {
        byte data = getModeFlag();
        return (data & 0x0f) == 0x02;
    }

    // tH[[hɐݒ
    public void setFollowMode()
    {
        if(worldObj.isRemote)
        {
            spawnParticle("heart");
            return;
        }
        byte data = getModeFlag();
        setModeFlag((byte)((data & 0xf0) | 0x02));
		chatMessage(getDollName()+" : Follow mode", 2);
		playSE("random.click", 0.3F, 0.6F);
        if(isOwner(ridingEntity))
        {
            mountEntity(null);
		}
    }

    // ChI[hǂ
    public boolean isRideonMode()
    {
        byte data = getModeFlag();
        return (data & 0x0f) == 0x03;
    }

    // ChI[hɐݒ
    public void setRideonMode()
    {
        if(worldObj.isRemote)
        {
            return;
        }
        byte data = getModeFlag();
        setModeFlag((byte)((data & 0xf0) | 0x03));
        if(!isOwner(ridingEntity))
        {
            mountEntity(getOwnerEntity());
		}
        chatMessage(getDollName()+" : Rideon mode", 2);
		playSE("random.click", 0.3F, 0.6F);
    }

    // `bgo̓x̕ύX
    public void toggleChatLevel()
    {
        setChatLevel((getChatLevel() + 1) % 4);
		playSE("random.click", 0.3F, 0.6F);
    }

    // `bgo̓x擾
    public int getChatLevel()
    {
        byte data = getModeFlag();
        return (int)((data & 0x30) >> 4);
    }

    // `bgo̓x̐ݒ
    public void setChatLevel(int level)
    {
        if(worldObj.isRemote)
        {
            return;
        }
        byte data = getModeFlag();
        setModeFlag((byte)((data & 0xcf) | (level << 4)));
        chatMessage(getDollName()+" : setChatLevel("+level+")", 0);
		playSE("random.click", 0.3F, 0.6F);
    }

    // @\̃IIt؂ւ
    public void toggleEnable()
    {
        setEnable(!isEnable());
    }

    // @\̃IItݒ
    public void setEnable(boolean enable)
    {
        if(enable)
        {
            byte data = getModeFlag();
            setModeFlag((byte)((data & 0x7f) | 0x80));
            chatMessage(getDollName()+" : Capability ON", 2);
            playSE("note.harp", 1.0F, (float)Math.pow(2D, (double)(23 - 12) / 12D));
        }
        else
        {
            byte data = getModeFlag();
            setModeFlag((byte)(data & 0x7f));
            chatMessage(getDollName()+" : Capability OFF", 2);
            playSE("note.harp", 1.0F, (float)Math.pow(2D, (double)(11 - 12) / 12D));
        }
    }

    // @\Iǂ
    public boolean isEnable()
    {
        byte data = getModeFlag();
        return ((data & 0x80) == 0x80);
    }


////////////////////////////////////////////////////////////////////////////////
// 

    // l`̏
    public void initializeDoll(String name)
    {
        // AI̍폜
        clearAI();

        // AI
        float speed = 0.25f;
        registerAI(0, new EntityDollAISwimming(this));
        registerAI(11, new EntityDollAIFollowOwner(this, speed));
        registerAI(12, new EntityDollAIWander(this, speed));
        registerAI(13, new EntityAIWatchClosest(this, EntityPlayer.class, 3F));
        registerAI(14, new EntityAIWatchClosest(this, EntityLiving.class, 6F));
        registerAI(15, new EntityAILookIdle(this));
        
        if(getDollName().equals("Shanghai"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollShanghai.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Item.swordGold, 1));
            registerAI(1, new EntityDollAISearchTarget(this));
            registerAI(2, new EntityDollAIAttackTarget(this, speed));
            registerAI(3, new EntityDollAIStealItem(this, speed));
        }
        else if(getDollName().equals("Horai"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollHorai.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Item.pickaxeGold, 1));
            registerAI(1, new EntityDollAIMineBlock(this, speed));
        }
        else if(getDollName().equals("Ooedo"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollOoedo.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Block.tnt, 1));
            registerAI(1, new EntityDollAIExplode(this, speed));
        }
        else if(getDollName().equals("Russia"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollRussia.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Block.chest, 1));
            registerAI(1, new EntityDollAICollectItem(this, speed));
            registerAI(2, new EntityDollAITorcher(this));
        }
        else if(getDollName().equals("Germany"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollGermany.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Item.axeGold, 1));
            registerAI(1, new EntityDollAICutTree(this, speed));
        }
        else if(getDollName().equals("London"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollLondon.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Item.eyeOfEnder, 1));
            registerAI(1, new EntityDollAISearchSpawner(this));
        }
        else if(getDollName().equals("Marisa"))
        {
            itemDollID = mod_Touhou_Alice_Dolls.dollMarisa.shiftedIndex;
            setCurrentItemOrArmor(0, new ItemStack(Block.mushroomRed, 1));
        }
        else
        {
            this.dataWatcher.updateObject(18, "Bare");
            this.texture = "/dolls/bare.png";
            itemDollID = mod_Touhou_Alice_Dolls.dollBare.shiftedIndex;
        }
    }

    // ̓
    private void updateFallingState()
    {
        this.field_70888_h = this.field_70886_e;
        this.field_70884_g = this.destPos;
        this.destPos = (float)((double)this.destPos + (double)(this.onGround ? -1 : 4) * 0.3D);

        if (this.destPos < 0.0F)
        {
            this.destPos = 0.0F;
        }

        if (this.destPos > 1.0F)
        {
            this.destPos = 1.0F;
        }

        if (!this.onGround && this.field_70889_i < 1.0F)
        {
            this.field_70889_i = 1.0F;
        }

        this.field_70889_i = (float)((double)this.field_70889_i * 0.9D);

        if (!this.onGround && this.motionY < 0.0D)
        {
            this.motionY *= 0.6D;
        }

        this.field_70886_e += this.field_70889_i * 2.0F;
    }

    // p[eBN̏o
    public void spawnParticle(String type)
    {
        Random r = new Random();
        double x = this.posX + (double)(r.nextFloat() * this.width * 2.0F) - (double)this.width;
        double y = this.posY + 0.5D + (double)(r.nextFloat() * this.height);
        double z = this.posZ + (double)(r.nextFloat() * this.width * 2.0F) - (double)this.width;
        double dx = r.nextGaussian() * 0.02D;
        double dy = r.nextGaussian() * 0.02D;
        double dz = r.nextGaussian() * 0.02D;
        this.worldObj.spawnParticle(type, x, y, z, dx, dy, dz);
    }

    // SȄo
    public void playSE(String type, float vol, float pitch)
    {
		worldObj.playSoundEffect(posX, posY+getEyeHeight(), posZ, type, vol, pitch);
    }
    
////////////////////////////////////////////////////////////////////////////////
// Cxg

    // Cxg̑傫
    @Override
    public int getSizeInventory()
    {
        if(getDollName().equals("Russia"))
        {
            return 36;
        }
        return 9;
    }

    // wXbg̃ACeX^bN擾
    @Override
    public ItemStack getStackInSlot(int index)
    {
        return this.dollInventory[index];
    }

    // wXbg̃ACeX^bN炷
    @Override
    public ItemStack decrStackSize(int index, int size)
    {
        if (this.dollInventory[index] != null)
        {
            ItemStack itemstack;
            
            if (this.dollInventory[index].stackSize <= size)
            {
                itemstack = this.dollInventory[index];
                this.dollInventory[index] = null;
                return itemstack;
            }
            else
            {
                itemstack = this.dollInventory[index].splitStack(size);
                
                if (this.dollInventory[index].stackSize == 0)
                {
                    this.dollInventory[index] = null;
                }
                
                return itemstack;
            }
        }
        else
        {
            return null;
        }
    }

    // ACe󂫃Xbg֒ǉ
    public boolean addItemStackToInventory(ItemStack par1ItemStack)
    {
        int var2;

        if (par1ItemStack.isItemDamaged())
        {
            var2 = this.getFirstEmptyStack();

            if (var2 >= 0)
            {
                this.dollInventory[var2] = ItemStack.copyItemStack(par1ItemStack);
                this.dollInventory[var2].animationsToGo = 5;
                par1ItemStack.stackSize = 0;
                return true;
            }
            else
            {
                return false;
            }
        }
        else
        {
            do
            {
                var2 = par1ItemStack.stackSize;
                par1ItemStack.stackSize = this.storePartialItemStack(par1ItemStack);
            }
            while (par1ItemStack.stackSize > 0 && par1ItemStack.stackSize < var2);

            return par1ItemStack.stackSize < var2;
        }
    }

    // ŏ̋󂫃X^bN擾
    public int getFirstEmptyStack()
    {
        for (int var1 = 0; var1 < this.getSizeInventory(); ++var1)
        {
            if (this.dollInventory[var1] == null)
            {
                return var1;
            }
        }

        return -1;
    }

    
    private int storeItemStack(ItemStack par1ItemStack)
    {
        for (int var2 = 0; var2 < this.getSizeInventory(); ++var2)
        {
            if (this.dollInventory[var2] != null
                && this.dollInventory[var2].itemID == par1ItemStack.itemID
                && this.dollInventory[var2].isStackable()
                && this.dollInventory[var2].stackSize < this.dollInventory[var2].getMaxStackSize()
                && this.dollInventory[var2].stackSize < this.getInventoryStackLimit()
                && (!this.dollInventory[var2].getHasSubtypes() || this.dollInventory[var2].getItemDamage() == par1ItemStack.getItemDamage())
                && ItemStack.areItemStackTagsEqual(this.dollInventory[var2], par1ItemStack))
            {
                return var2;
            }
        }

        return -1;
    }

    private int storePartialItemStack(ItemStack par1ItemStack)
    {
        int var2 = par1ItemStack.itemID;
        int var3 = par1ItemStack.stackSize;
        int var4;

        if (par1ItemStack.getMaxStackSize() == 1)
        {
            var4 = this.getFirstEmptyStack();

            if (var4 < 0)
            {
                return var3;
            }
            else
            {
                if (this.dollInventory[var4] == null)
                {
                    this.dollInventory[var4] = ItemStack.copyItemStack(par1ItemStack);
                }

                return 0;
            }
        }
        else
        {
            var4 = this.storeItemStack(par1ItemStack);

            if (var4 < 0)
            {
                var4 = this.getFirstEmptyStack();
            }

            if (var4 < 0)
            {
                return var3;
            }
            else
            {
                if (this.dollInventory[var4] == null)
                {
                    this.dollInventory[var4] = new ItemStack(var2, 0, par1ItemStack.getItemDamage());

                    if (par1ItemStack.hasTagCompound())
                    {
                        this.dollInventory[var4].setTagCompound((NBTTagCompound)par1ItemStack.getTagCompound().copy());
                    }
                }

                int var5 = var3;

                if (var3 > this.dollInventory[var4].getMaxStackSize() - this.dollInventory[var4].stackSize)
                {
                    var5 = this.dollInventory[var4].getMaxStackSize() - this.dollInventory[var4].stackSize;
                }

                if (var5 > this.getInventoryStackLimit() - this.dollInventory[var4].stackSize)
                {
                    var5 = this.getInventoryStackLimit() - this.dollInventory[var4].stackSize;
                }

                if (var5 == 0)
                {
                    return var3;
                }
                else
                {
                    var3 -= var5;
                    this.dollInventory[var4].stackSize += var5;
                    this.dollInventory[var4].animationsToGo = 5;
                    return var3;
                }
            }
        }
    }

    // GUIꂽɃhbvACe擾
    @Override
    public ItemStack getStackInSlotOnClosing(int index)
    {
        if (this.dollInventory[index] != null)
        {
            ItemStack itemstack = this.dollInventory[index];
            this.dollInventory[index]= null;
            return itemstack;
        }
        else
        {
            return null;
        }
    }

    // wXbgɃACeݒ肷
    @Override
    public void setInventorySlotContents(int index, ItemStack itemstack)
    {
        this.dollInventory[index] = itemstack;
            
        if (itemstack != null && itemstack.stackSize > this.getInventoryStackLimit())
        {
            itemstack.stackSize = this.getInventoryStackLimit();
        }
    }

    // Cxg̖O
    @Override
    public String getInvName()
    {
        return getDollName();
    }

    // Cxg̍őX^bN
    @Override
    public int getInventoryStackLimit()
    {
        return 64;
    }

    // CxgύXꂽƂɌĂ΂
    @Override
    public void onInventoryChanged()
    {
        ItemStack itemstack;
        ItemArmor itemarmor;

        // wbg
        itemstack = dollInventory[getSizeInventory()-1];
        if(itemstack == null)
        {
            setCurrentItemOrArmor(4, null);
        }
        else
        {
            if(itemstack.getItem() instanceof ItemArmor)
            {
                itemarmor = (ItemArmor)(itemstack.getItem());
                if(itemarmor.armorType == 0)
                {
                    setCurrentItemOrArmor(4, itemstack);
                }
            }
            else if((itemstack.itemID == Block.pumpkin.blockID)
               || (itemstack.itemID == Item.skull.shiftedIndex))
            {
                setCurrentItemOrArmor(4, itemstack);
            }
            else
            {
                setCurrentItemOrArmor(4, null);
            }
        }
        
        // `FXgv[g
        itemstack = dollInventory[getSizeInventory()-2];
        if(itemstack == null)
        {
            setCurrentItemOrArmor(3, null);
        }
        else
        {
            if(itemstack.getItem() instanceof ItemArmor)
            {
                itemarmor = (ItemArmor)(itemstack.getItem());
                if(itemarmor.armorType == 1)
                {
                    setCurrentItemOrArmor(3, itemstack);
                }
            }
            else
            {
                setCurrentItemOrArmor(3, null);
            }
        }
        
        // MX
        itemstack = dollInventory[getSizeInventory()-3];
        if(itemstack == null)
        {
            setCurrentItemOrArmor(2, null);
        }
        else
        {
            if(itemstack.getItem() instanceof ItemArmor)
            {
                itemarmor = (ItemArmor)(itemstack.getItem());
                if(itemarmor.armorType == 2)
                {
                    setCurrentItemOrArmor(2, itemstack);
                }
            }
            else
            {
                setCurrentItemOrArmor(2, null);
            }
        }
        
        // u[c
        itemstack = dollInventory[getSizeInventory()-4];
        if(itemstack == null)
        {
            setCurrentItemOrArmor(1, null);
        }
        else
        {
            if(itemstack.getItem() instanceof ItemArmor)
            {
                itemarmor = (ItemArmor)(itemstack.getItem());
                if(itemarmor.armorType == 3)
                {
                    setCurrentItemOrArmor(1, itemstack);
                }
            }
            else
            {
                setCurrentItemOrArmor(1, null);
            }
        }
    }

    // vC[g邩ǂ
    @Override
    public boolean isUseableByPlayer(EntityPlayer entityplayer)
    {
        return isOwner(entityplayer);
    }

    // CxgJꂽƂĂ΂
    @Override
    public void openChest()
    {
        isInventoryOpened = true;
    }

    // CxgꂽƂĂ΂
    @Override
    public void closeChest()
    {
        isInventoryOpened = false;
    }

////////////////////////////////////////////////////////////////////////////////
// e|[g

    public void teleportToEntity(Entity entity, double r)
    {
        teleportToXYZ(entity.posX, entity.posY, entity.posZ, r);
    }

    public void teleportToXYZ(double x, double y, double z, double r)
    {
        double d = Math.sqrt((posX-x)*(posX-x) + (posY-y)*(posY-y) + (posZ-z)*(posZ-z));
        
        double newX = x + (posX - x) / d * r;
        double newY = y + (posY - y) / d * r;
        double newZ = z + (posZ - z) / d * r;

        this.setPosition(newX, newY, newZ);
        this.func_85030_a("mob.endermen.portal", 0.5F, 1.0F);
    }

////////////////////////////////////////////////////////////////////////////////
// AI

    private void registerAI(int priority, EntityAIBase ai)
    {
        this.tasks.addTask(priority, ai);
        registeredTasks.add(ai);
    }

    private void clearAI()
    {
        Iterator it = this.registeredTasks.iterator();

        while (it.hasNext())
        {
            EntityAIBase ai = (EntityAIBase)it.next();
            
            this.tasks.func_85156_a(ai);
            it.remove();
        }
    }
    
////////////////////////////////////////////////////////////////////////////////
// `bg

    // `bgM
    protected void chatMessage(String msg, int level)
    {
        EntityPlayer entityplayer = getOwnerEntity();
        
        if(entityplayer != null && !entityplayer.worldObj.isRemote && getChatLevel()>=level)
		{
			if(entityplayer != null && getChatLevel()==3)
			{
				System.out.println("  "+msg);
			}
			if(!lastMsg.equalsIgnoreCase(msg))
			{
				entityplayer.addChatMessage(msg);
				lastMsg = msg;
			}
		}

    }

////////////////////////////////////////////////////////////////////////////////
// W

    // WtOݒ
    public static void setGatheringCall(boolean call)
    {
        gatheringCall = call;
    }
}
