package net.minecraft.src;

import java.util.*;
import java.util.regex.*;

public class EntityDollAIAttackTarget extends EntityAIBase
{
    private EntityDoll theDoll;
    private World theWorld;
    private EntityLiving theTarget;
    private float speed;
    private int counter;

    public static String targetEntity;
    public static int attackStrength;
    
    public EntityDollAIAttackTarget(EntityDoll entitydoll, float s)
    {
        theDoll = entitydoll;
        theWorld = entitydoll.worldObj;
        speed = s;
        counter = 0;
        setMutexBits(0x3);
    }

    @Override
    public boolean shouldExecute()
    {
        if(!theDoll.isEnable())
        {
            return false;
        }

        theTarget = theDoll.getAttackTarget();
        if(theTarget == null)
        {
            return false;
        }

        String name = theTarget.getEntityString();
        if(name == null)
        {
            return false;
        }

        Pattern targetPattern = Pattern.compile(targetEntity);
        Matcher targetMatcher = targetPattern.matcher(name);

        if(!targetMatcher.find())
        {
            return false;
        }

        return true;
    }

    @Override
    public void startExecuting()
    {
        counter = 20;
    }
    
    @Override
    public boolean continueExecuting()
    {
        return shouldExecute() && !theDoll.getNavigator().noPath();
    }

    @Override
    public void resetTask()
    {
        theDoll.getNavigator().clearPathEntity();
    }

    @Override
    public void updateTask()
    {
        theDoll.getLookHelper().setLookPositionWithEntity(theTarget, 10F, theDoll.getVerticalFaceSpeed());
        theDoll.getNavigator().tryMoveToEntityLiving(theTarget, speed);

        if(theDoll.getDistanceSqToEntity(theTarget) < 9f && theDoll.getEntitySenses().canSee(theTarget))
        {
            if(counter < 20)
            {
                ++counter;
            }
            else
            {
                counter = 0;

                theTarget.attackEntityFrom(DamageSource.causePlayerDamage(theDoll.getOwnerEntity()),attackStrength);
                theDoll.swingItem();
            }
        }
        else
        {
            counter = counter > 0 ? counter - 1 : 0;
        }
    }
}
