package net.minecraft.src;

import java.util.*;
import java.util.regex.*;

public class EntityDollAICollectItem extends EntityAIBase
{
    private EntityDoll theDoll;
    private World theWorld;
    private EntityItem theItem;
    private float speed;
    private int counter;

    public static double searchRange;
    public static double searchHeight;
    public static float canCollectRange;
    
    public EntityDollAICollectItem(EntityDoll entitydoll, float s)
    {
        theDoll = entitydoll;
        theWorld = entitydoll.worldObj;
        theItem = null;
        speed = s;
        counter = 0;
        setMutexBits(0x3);
    }

    @Override
    public boolean shouldExecute()
    {
        if(!theDoll.isEnable())
        {
            return false;
        }

        if(counter < 2)
        {
            ++counter;
            return false;
        }
        counter = 0;

        List<EntityItem> itemList = (List<EntityItem>)(theWorld.getEntitiesWithinAABB(EntityItem.class, theDoll.boundingBox.expand(searchRange, searchHeight, searchRange)));

        theItem = null;
        for(EntityItem e : itemList)
        {
            if(theWorld.getPathEntityToEntity(theDoll, e, (float)searchRange, true, false, false, true)==null)
            {
                continue;
            }
            if(theItem == null)
            {
                theItem = e;
            }
            else
            {
                if(theDoll.getDistanceSqToEntity(theItem)>theDoll.getDistanceSqToEntity(e))
                {
                    theItem = e;
                }
            }
        }
        if(theItem ==null)
        {
            return false;
        }

        // o͕̍쐬
        StringBuffer msg=new StringBuffer(theDoll.getDollName() + " : ");
        String itemname = theItem.item.getItem().getItemName();
        if(itemname == null)
        {
            itemname = "unknown";
        }
        msg.append(itemname);
        theDoll.chatMessage(msg.toString(), 3);
        
        return true;
    }

    @Override
    public boolean continueExecuting()
    {
        return theDoll.isEnable() && (theDoll.isPatrolMode() || theDoll.isFollowMode())
            && theItem != null && !theItem.isDead
            && theItem.item != null && theItem.item.stackSize != 0 && (counter < 200);
    }

    @Override
    public void startExecuting()
    {
        counter = 0;
    }

    @Override
    public void resetTask()
    {
        theDoll.getNavigator().clearPathEntity();
    }

    @Override
    public void updateTask()
    {
        counter++;
        theDoll.getLookHelper().setLookPositionWithEntity(theItem, 10F, theDoll.getVerticalFaceSpeed());
        
        if(theDoll.isPatrolMode() || theDoll.isFollowMode())
        {
            theDoll.getNavigator().tryMoveToXYZ(theItem.posX, theItem.posY, theItem.posZ, speed);
        }

        if(theDoll.getDistanceToEntity(theItem) < canCollectRange)
        {
            if(theDoll.addItemStackToInventory(theItem.item))
            {
                theWorld.playSoundAtEntity(theDoll, "random.pop", 0.2F, ((theDoll.getRNG().nextFloat() - theDoll.getRNG().nextFloat()) * 0.7F + 1.0F) * 2.0F);
                if(theItem.item.stackSize <= 0)
                {
                    theItem.setDead();
                }
                counter = 0;
            }
            else
            {
                if(counter == 100)
                {
                    theDoll.chatMessage(theDoll.getDollName() + " : Can't pick up!", 1);
                    theItem.motionX += 0.1D - 0.2D*theDoll.getRNG().nextDouble();
                    theItem.motionY += 0.3D + 0.1D*theDoll.getRNG().nextDouble();
                    theItem.motionZ += 0.1D - 0.2D*theDoll.getRNG().nextDouble();
                }
            }
        }
    }
}
