////////////////////////////////////////////////////////////////////////////////
// ǂ

package net.minecraft.src;

public class EntityDollAIFollowOwner extends EntityAIBase
{
    private EntityDoll theDoll;
    private float speed;
    private World theWorld;
    private float maxDist;
    private float minDist;

    public EntityDollAIFollowOwner(EntityDoll entitydoll, float s)
    {
        theDoll = entitydoll;
        theWorld = entitydoll.worldObj;
        speed = s;
        minDist = 3F;
        maxDist = 12F;
        
        setMutexBits(0x3);
    }

    public boolean shouldExecute()
    {
        EntityPlayer player = theDoll.getOwnerEntity();
        
        if (player == null)
        {
            return false;
        }

        if (!theDoll.isFollowMode())
        {
            return false;
        }

        if(theDoll.ridingEntity != null)
        {
            return false;
        }

        if (theDoll.getDistanceSqToEntity(player) < (minDist * minDist))
        {
            return false;
        }

        return true;
    }

    public void resetTask()
    {
        theDoll.getNavigator().clearPathEntity();
    }

    public void updateTask()
    {
        EntityPlayer player = theDoll.getOwnerEntity();
        
        theDoll.getLookHelper().setLookPositionWithEntity(player, 10F, theDoll.getVerticalFaceSpeed());

        if (!theDoll.isFollowMode())
        {
            return;
        }

        if (theDoll.getNavigator().tryMoveToEntityLiving(player, speed))
        {
            return;
        }

        if (theDoll.getDistanceSqToEntity(player) < (maxDist * maxDist))
        {
            return;
        }

        int i = MathHelper.floor_double(player.posX) - 2;
        int j = MathHelper.floor_double(player.posZ) - 2;
        int k = MathHelper.floor_double(player.boundingBox.minY);

        for (int l = 0; l <= 4; l++)
        {
            for (int i1 = 0; i1 <= 4; i1++)
            {
                if ((l < 1 || i1 < 1 || l > 3 || i1 > 3) && theWorld.doesBlockHaveSolidTopSurface(i + l, k - 1, j + i1) && !theWorld.isBlockNormalCube(i + l, k, j + i1) && !theWorld.isBlockNormalCube(i + l, k + 1, j + i1))
                {
                    theDoll.setLocationAndAngles((float)(i + l) + 0.5F, k, (float)(j + i1) + 0.5F, theDoll.rotationYaw, theDoll.rotationPitch);
                    theDoll.getNavigator().clearPathEntity();
                    return;
                }
            }
        }
    }
}
