package net.minecraft.src;

import java.util.*;
import java.util.regex.*;

public class EntityDollAISearchTarget extends EntityAIBase
{
    private EntityDoll theDoll;
    private World theWorld;
    private EntityLiving theTarget;
    private int counter;

    public static String searchEntity;
    public static String targetEntity;
    public static double searchRange;
    public static double searchHeight;
    
    public EntityDollAISearchTarget(EntityDoll entitydoll)
    {
        theDoll = entitydoll;
        theWorld = entitydoll.worldObj;
        counter = 0;
        setMutexBits(0x0);
    }

    @Override
    public boolean shouldExecute()
    {
        if(!theDoll.isEnable())
        {
            return false;
        }
        
        if(counter < 20)
        {
            ++counter;
            return false;
        }
        counter = 0;

        List<EntityLiving> targetList = (List<EntityLiving>)(theWorld.getEntitiesWithinAABB(EntityLiving.class, theDoll.boundingBox.expand(searchRange, searchHeight, searchRange)));
        Pattern searchPattern = Pattern.compile(searchEntity);
        Pattern targetPattern = Pattern.compile(targetEntity);
        Matcher searchMatcher, targetMatcher;
        TreeMap<String, Integer> entityCount = new TreeMap<String, Integer>();
        EntityLiving stealTarget = null;

        theTarget = null;
        for(EntityLiving e : targetList)
        {
            String name = e.getEntityString();
            if(name == null)
            {
                continue;
            }

            //TmΏۂǂ
            searchMatcher = searchPattern.matcher(name);
            if(searchMatcher.find())
            {
                if(entityCount.containsKey(name))
                {
                    int c = entityCount.get(name).intValue() + 1;
                    entityCount.put(name, new Integer(c));
                }
                else
                {
                    entityCount.put(name, new Integer(1));
                }
            }

            //U
            if(theDoll.isPatrolMode())
            {
                targetMatcher = targetPattern.matcher(name);
                if(targetMatcher.find())
                {
                    if(theTarget == null)
                    {
                        theTarget = e;
                    }
                    else
                    {
                        if(theDoll.getDistanceSqToEntity(theTarget)
                           > theDoll.getDistanceSqToEntity(e))
                        {
                            theTarget = e;
                        }
                    }
                }
            }

            //h
            if(theDoll.isFollowMode())
            {
                Entity tt = null;
                if(e instanceof EntityCreature)
                {
                    tt = ((EntityCreature)e).getEntityToAttack();
                }
                else
                {
                    tt = e.getAttackTarget();
                }
                if(tt instanceof EntityPlayer && theDoll.isOwner((EntityPlayer)tt))
                {
                    if(theTarget == null)
                    {
                        theTarget = e;
                    }
                    else
                    {
                        if(theDoll.getDistanceSqToEntity(theTarget)
                           > theDoll.getDistanceSqToEntity(e))
                        {
                            theTarget = e;
                        }
                    }
                }
            }

            //NW
            if(theDoll.isPatrolMode())
            {
                if(name.equalsIgnoreCase("Sheep"))
                {
                    EntitySheep sheep = (EntitySheep)e;

                    if(!sheep.getSheared() && !sheep.isChild())
                    {
                        if(stealTarget == null)
                        {
                            stealTarget = e;
                        }
                        else
                        {
                            if(theDoll.getDistanceSqToEntity(stealTarget)
                               > theDoll.getDistanceSqToEntity(e))
                            {
                                stealTarget = e;
                            }
                        }
                    }
                }
                else if(name.equalsIgnoreCase("Chicken") || name.equalsIgnoreCase("MushroomCow") || name.equalsIgnoreCase("VillagerGolem"))
                {
                    if(stealTarget == null)
                    {
                        stealTarget = e;
                    }
                    else
                    {
                        if(theDoll.getDistanceSqToEntity(stealTarget)
                           > theDoll.getDistanceSqToEntity(e))
                        {
                            stealTarget = e;
                        }
                    }
                }
            }
        }

        // o͕̍쐬
        StringBuffer msg=new StringBuffer(theDoll.getDollName() + " : ");
        
        if(entityCount.isEmpty())
        {
            msg.append("No target");
            theDoll.chatMessage(msg.toString(),2);
        }
        else
        {
            Iterator it = entityCount.keySet().iterator();
            while(it.hasNext())
            {
                String s = (String)it.next();
                int v = entityCount.get(s).intValue();
                msg.append(s);
                msg.append("[");
                msg.append(v);
                msg.append("] ");
            }
            theDoll.chatMessage(msg.toString(),1);
        }

        //^[Qbgɐݒ
        theDoll.setAttackTarget(theTarget == null ? stealTarget : theTarget);

        return true;
    }

    @Override
    public boolean continueExecuting()
    {
        return false;
    }
}
