///////////////////////////////////////////////////////////
// Rɕ

package net.minecraft.src;

import java.util.Random;

public class EntityDollAIWander extends EntityAIBase
{
    private EntityDoll theDoll;
    private double xPosition;
    private double yPosition;
    private double zPosition;
    private float speed;

    public EntityDollAIWander(EntityDoll entitydoll, float s)
    {
        theDoll = entitydoll;
        speed = s;
        setMutexBits(0x1);
    }

    public boolean shouldExecute()
    {
        if(!theDoll.isPatrolMode())
        {
            return false;
        }

        Random rand = theDoll.getRNG();

        if (theDoll.getRNG().nextInt(60) != 0)
        {
            return false;
        }
        xPosition = theDoll.posX + rand.nextInt(2*4)-4;
        yPosition = theDoll.posY + rand.nextInt(2*4)-4;
        zPosition = theDoll.posZ + rand.nextInt(2*4)-4;

        return true;
    }

    public boolean continueExecuting()
    {
        if(!theDoll.isPatrolMode())
        {
            theDoll.getNavigator().clearPathEntity();
            return false;
        }
        if(theDoll.getNavigator().noPath())
        {
            return false;
        }
        return true;
    }

    public void startExecuting()
    {
        theDoll.getNavigator().tryMoveToXYZ(xPosition, yPosition, zPosition, speed);
    }
}
