////////////////////////////////////////////////////////////////////////////////
// l`ACe

package net.minecraft.src;


public class ItemDoll extends Item
{

	public ItemDoll(int i)
	{
		super(i);
		maxStackSize = 16;
	}
	
	@Override
	public boolean isFull3D()
	{
		return true;
	}
	
	@Override
	public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int i, int j, int k, int l, float p, float q, float r)
	{
        if (world.isRemote)
        {
            return true;
        }
        else
        {
            int currentID = world.getBlockId(i, j, k);
            i += Facing.offsetsXForSide[l];
            j += Facing.offsetsYForSide[l];
            k += Facing.offsetsZForSide[l];
            double offsetY = 0.0D;

            if (l == 1 && Block.blocksList[currentID] != null && Block.blocksList[currentID].getRenderType() == 11)
            {
                offsetY = 0.5D;
            }

            Entity entity = ItemMonsterPlacer.spawnCreature(world, mod_Touhou_Alice_Dolls.dollEntityID, (double)i + 0.5D, (double)j + offsetY, (double)k + 0.5D);
            if (entity != null)
            {
                EntityDoll doll = (EntityDoll)entity;
                doll.setOwnerName(entityplayer.username);
                if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollShanghai.shiftedIndex)
                {
                    doll.setDollName("Shanghai");
                }
                else if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollHorai.shiftedIndex)
                {
                    doll.setDollName("Horai");
                }
                else if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollOoedo.shiftedIndex)
                {
                    doll.setDollName("Ooedo");
                }
                else if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollRussia.shiftedIndex)
                {
                    doll.setDollName("Russia");
                }
                else if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollGermany.shiftedIndex)
                {
                    doll.setDollName("Germany");
                }
                else if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollLondon.shiftedIndex)
                {
                    doll.setDollName("London");
                }
                else if(itemstack.getItem().shiftedIndex == mod_Touhou_Alice_Dolls.dollMarisa.shiftedIndex)
                {
                    doll.setDollName("Marisa");
                }
                else
                {
                    doll.setDollName("Bare");
                }
                    
                --itemstack.stackSize;
            }

            return true;
        }
    }
}
