////////////////////////////////////////////////////////////////////////////////
// h[RAACe

package net.minecraft.src;

import java.util.*;

public class ItemDollCore extends Item
{

	public ItemDollCore(int i)
	{
		super(i);
		maxStackSize = 16;
		isUsing = false;
	}
	
	@Override
	public boolean isFull3D()
	{
		return true;
	}

    @Override
	public int getDamageVsEntity(Entity entity)
	{
		return entity instanceof EntityDoll ? 64 : 1;
	}
	
	@Override
	public EnumAction getItemUseAction(ItemStack itemstack)
	{
		return EnumAction.bow;
	}
	
	@Override
	public void onPlayerStoppedUsing(ItemStack itemstack, World world, EntityPlayer entityplayer, int i)
	{
		isUsing = false;
        EntityDoll.setGatheringCall(false);
	}
	
	@Override
	public void onUpdate(ItemStack itemstack, World world, Entity entity, int i, boolean flag)
	{
		if(isUsing)
		{
			++chargeCounter;

            if(chargeCounter == 15)
            {
                EntityDoll.setGatheringCall(true);
            }
        }
	}
	
	@Override
	public int getMaxItemUseDuration(ItemStack itemstack)
	{
		return 16;
	}
	
	@Override
	public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
	{
		entityplayer.setItemInUse(itemstack, getMaxItemUseDuration(itemstack));
		chargeCounter = 0;
		isUsing = true;
		
		return itemstack;
	}

    // E܂Ń`[WꂽƂɌĂ΂
    protected void onTriggered()
    {
    }
	
	private int chargeCounter;
	private boolean isUsing;
}
