package net.minecraft.src;

import org.lwjgl.opengl.GL11;

////////////////////////////////////////////////////////////////////////////////
// l`̕`

public class RenderDoll extends RenderLiving
{
    protected ModelDoll modelDollMain;
    protected float field_77070_b;
    protected ModelDoll modelDollArmor1;
    protected ModelDoll modelDollArmor2;
    private static final String[] armorType = new String[] {"cloth", "chain", "iron", "diamond", "gold"};

    public RenderDoll()
    {
        this(new ModelDoll(), 0.5F);
    }

    public RenderDoll(ModelDoll modeldoll, float shadow)
    {
        this(modeldoll, shadow, 1.0F);
    }

    public RenderDoll(ModelDoll modeldoll, float shadow, float par3)
    {
        super(modeldoll, shadow);
        this.modelDollMain = modeldoll;
        this.field_77070_b = par3;
        this.initAromr();
    }

    protected void initAromr()
    {
        this.modelDollArmor1 = new ModelDoll(0F);
        this.modelDollArmor2 = new ModelDoll(0F);
    }

    /**
     * Queries whether should render the specified pass or not.
     */
    protected int shouldRenderPass(EntityLiving par1EntityLiving, int slotIndex, float par3)
    {
        ItemStack itemstack = par1EntityLiving.getCurrentArmor(3 - slotIndex);

        if (itemstack != null)
        {
            Item item = itemstack.getItem();

            if (item instanceof ItemArmor)
            {
                ItemArmor armor = (ItemArmor)item;
                this.loadTexture("/dolls/armor/" + armorType[armor.renderIndex] + "_" + (slotIndex >= 2 ? 2 : 1) + ".png");
                ModelDoll modelarmor = slotIndex >= 2 ? modelDollArmor2 : this.modelDollArmor1;
                modelarmor.bipedHead.showModel = slotIndex == 0;
                modelarmor.bipedBody.showModel = slotIndex == 1 || slotIndex == 2;
                modelarmor.bipedRightArm.showModel = slotIndex == 1;
                modelarmor.bipedLeftArm.showModel = slotIndex == 1;
                modelarmor.skirt1.showModel = slotIndex == 2;
                modelarmor.skirt2.showModel = slotIndex == 2;
                modelarmor.bipedRightLeg.showModel = slotIndex == 3;
                modelarmor.bipedLeftLeg.showModel = slotIndex == 3;
                this.setRenderPassModel(modelarmor);

                if (modelarmor != null)
                {
                    modelarmor.onGround = this.mainModel.onGround;
                }

                if (modelarmor != null)
                {
                    modelarmor.isRiding = this.mainModel.isRiding;
                }

                if (modelarmor != null)
                {
                    modelarmor.isChild = this.mainModel.isChild;
                }

                float var8 = 1.0F;

                if (armor.getArmorMaterial() == EnumArmorMaterial.CLOTH)
                {
                    int var9 = armor.getColor(itemstack);
                    float var10 = (float)(var9 >> 16 & 255) / 255.0F;
                    float var11 = (float)(var9 >> 8 & 255) / 255.0F;
                    float var12 = (float)(var9 & 255) / 255.0F;
                    GL11.glColor3f(var8 * var10, var8 * var11, var8 * var12);

                    if (itemstack.isItemEnchanted())
                    {
                        return 31;
                    }

                    return 16;
                }

                GL11.glColor3f(var8, var8, var8);

                if (itemstack.isItemEnchanted())
                {
                    return 15;
                }

                return 1;
            }
        }

        return -1;
    }

    protected void func_82408_c(EntityLiving par1EntityLiving, int slotIndex, float par3)
    {
        ItemStack itemstack = par1EntityLiving.getCurrentArmor(3 - slotIndex);

        if (itemstack != null)
        {
            Item item = itemstack.getItem();

            if (item instanceof ItemArmor)
            {
                ItemArmor armor = (ItemArmor)item;
                this.loadTexture("/dolls/armor/trans.png");
                float var7 = 1.0F;
                GL11.glColor3f(var7, var7, var7);
            }
        }
    }

    public void doRenderLiving(EntityLiving par1EntityLiving, double par2, double par4, double par6, float par8, float par9)
    {
        float var10 = 1.0F;
        GL11.glColor3f(var10, var10, var10);
        ItemStack var11 = par1EntityLiving.getHeldItem();
        this.func_82420_a(par1EntityLiving, var11);
        double var12 = par4 - (double)par1EntityLiving.yOffset;

        if (par1EntityLiving.isSneaking() && !(par1EntityLiving instanceof EntityPlayerSP))
        {
            var12 -= 0.125D;
        }

        super.doRenderLiving(par1EntityLiving, par2, var12, par6, par8, par9);
        
        this.modelDollArmor1.aimedBow = this.modelDollArmor2.aimedBow = this.modelDollMain.aimedBow = false;
        this.modelDollArmor1.isSneak = this.modelDollArmor2.isSneak = this.modelDollMain.isSneak = false;
        this.modelDollArmor1.heldItemRight = this.modelDollArmor2.heldItemRight = this.modelDollMain.heldItemRight = 0;
    }

    protected void func_82420_a(EntityLiving par1EntityLiving, ItemStack par2ItemStack)
    {
        this.modelDollArmor1.heldItemRight =
            this.modelDollArmor2.heldItemRight =
            this.modelDollMain.heldItemRight = par2ItemStack != null ? 1 : 0;
        
        this.modelDollArmor1.isSneak =
            this.modelDollArmor2.isSneak =
            this.modelDollMain.isSneak = par1EntityLiving.isSneaking();
    }

    protected void renderEquippedItems(EntityLiving par1EntityLiving, float par2)
    {
        float var3 = 1.0F;
        GL11.glColor3f(var3, var3, var3);
        super.renderEquippedItems(par1EntityLiving, par2);
        ItemStack heldItem = par1EntityLiving.getHeldItem();
        ItemStack var5 = par1EntityLiving.getCurrentArmor(3);
        float var6;
        float dollScale = 0.5F;
        EntityDoll theDoll = (EntityDoll)par1EntityLiving;

        // ɒǏ]p[c̕`
        if(var5 != null)
        {
            GL11.glPushMatrix();
            this.modelDollMain.bipedHead.postRender(0.0625F);
            
            if (var5.getItem().shiftedIndex == Block.pumpkin.blockID)
            {
                if (RenderBlocks.renderItemIn3d(Block.blocksList[var5.itemID].getRenderType()))
                {
                    var6 = 0.625F;
                    GL11.glTranslatef(0.0F, -0.25F, 0.0F);
                    GL11.glRotatef(90.0F, 0.0F, 1.0F, 0.0F);
                    GL11.glScalef(var6, -var6, -var6);
                }

                this.renderManager.itemRenderer.renderItem(par1EntityLiving, var5, 0);
            }
            else if (var5.getItem().shiftedIndex == Item.skull.shiftedIndex)
            {
                var6 = 1.0625F;
                GL11.glScalef(var6, -var6, -var6);
                String var7 = "";

                if (var5.hasTagCompound() && var5.getTagCompound().hasKey("SkullOwner"))
                {
                    var7 = var5.getTagCompound().getString("SkullOwner");
                }

                TileEntitySkullRenderer.skullRenderer.func_82393_a(-0.5F, 0.0F, -0.5F, 1, 180.0F, var5.getItemDamage(), var7);
            }

            GL11.glPopMatrix();
        }
        // if(heldItem != null)
        // {
        //     GL11.glPushMatrix();
        //     this.modelDollMain.bipedHead.postRender(0.0625F);

        //     if(heldItem.itemID == Item.eyeOfEnder.shiftedIndex)
        //     {
		// 		var6 = 0.25F;
		// 		GL11.glScalef(var6, var6, var6);

		// 		GL11.glRotatef(360F*theDoll.searchDev, 0.0F, 1.0F, 0.0F);
		// 		GL11.glTranslatef(0.4375F+0.03125F, -2.25F+0.0625F, 0.0625F);
		// 		GL11.glRotatef(-335F, 0.0F, 0.0F, 1.0F);
		// 		GL11.glRotatef(-50F, 0.0F, 1.0F, 0.0F);
		// 		GL11.glScalef(1.0F/1.5F, 1.0F/1.5F, 1.0F/1.5F);
		// 		GL11.glTranslatef(0.0F, 0.3F, 0.0F);
                
        //         this.renderManager.itemRenderer.renderItem(par1EntityLiving, heldItem, 0);
        //     }

        //     GL11.glPopMatrix();
        // }

        // ɒǏ]p[c̕`
        if (heldItem != null)
        {
            GL11.glPushMatrix();
            this.modelDollMain.bipedRightArm.postRender(0.0625F);
            GL11.glTranslatef(0.125F, 0.125F, 0.0625F);

            if (heldItem.itemID < 256 && RenderBlocks.renderItemIn3d(Block.blocksList[heldItem.itemID].getRenderType()))
            {
                if(heldItem.itemID == Block.chest.blockID)
                {
                    var6 = 0.5F * dollScale;
                    GL11.glTranslatef(0.0F, 0.1375F, -0.0625F);
                }
                else
                {
                    var6 = 0.45F * dollScale;
                    GL11.glTranslatef(0.0F, 0.15F, -0.0625F);
                }
                var6 *= 0.75F;
                GL11.glRotatef(20.0F, 1.0F, 0.0F, 0.0F);
                GL11.glRotatef(45.0F, 0.0F, 1.0F, 0.0F);
                GL11.glScalef(var6, -var6, var6);
            }
            else if (heldItem.itemID == Item.bow.shiftedIndex)
            {
                var6 = 0.625F * dollScale;
                GL11.glTranslatef(0.0F, 0.125F, 0.125F);
                GL11.glRotatef(-20.0F, 0.0F, 1.0F, 0.0F);
                GL11.glScalef(var6, -var6, var6);
                GL11.glRotatef(-100.0F, 1.0F, 0.0F, 0.0F);
                GL11.glRotatef(45.0F, 0.0F, 1.0F, 0.0F);
            }
            else if (Item.itemsList[heldItem.itemID].isFull3D())
            {
                var6 = 0.625F * dollScale;

                if (Item.itemsList[heldItem.itemID].shouldRotateAroundWhenRendering())
                {
                    GL11.glRotatef(180.0F, 0.0F, 0.0F, 1.0F);
                    GL11.glTranslatef(0.0F, -0.125F, 0.0F);
                }

                this.func_82422_c();
                GL11.glScalef(var6, -var6, var6);
                GL11.glRotatef(-100.0F, 1.0F, 0.0F, 0.0F);
                GL11.glRotatef(45.0F, 0.0F, 1.0F, 0.0F);
            }
            else
            {
                var6 = 0.4F * dollScale;
                GL11.glTranslatef(0.0875F, 0.0625F, -0.125F);
                GL11.glScalef(var6, var6, var6);
                GL11.glRotatef(60.0F, 0.0F, 0.0F, 1.0F);
                GL11.glRotatef(-90.0F, 1.0F, 0.0F, 0.0F);
                GL11.glRotatef(20.0F, 0.0F, 0.0F, 1.0F);
            }

            // if(heldItem.itemID != Item.eyeOfEnder.shiftedIndex)
            // {
            this.renderManager.itemRenderer.renderItem(par1EntityLiving, heldItem, 0);
            
            if (heldItem.getItem().requiresMultipleRenderPasses())
            {
                this.renderManager.itemRenderer.renderItem(par1EntityLiving, heldItem, 1);
            }
            // }

            GL11.glPopMatrix();
        }
    }

    protected void func_82422_c()
    {
        GL11.glTranslatef(0.0F, 0.0875F, -0.05F);
    }

    public void doRender(Entity par1Entity, double par2, double par4, double par6, float par8, float par9)
    {
        this.doRenderLiving((EntityLiving)par1Entity, par2, par4, par6, par8, par9);
    }
}
